(function() {
    var config = require.config({
        baseUrl: 'js',
        paths: {
            samples: '../samples/compiled',
            templates: '../templates',
            test_screenplays: '../test/data/test_screenplays',
            test: '../test',
            jquery: 'libs/jquery-1.11.1.min',
            'jquery-ui': 'libs/jquery-ui-1.10.3.amd.min',
            'jquery-ui-touch-punch': 'libs/jquery-ui.touch-punch.amd.min',
            handlebars: '../node_modules/handlebars/dist/handlebars.amd',
            logger: 'libs/logger',
            lodash: '../node_modules/lodash/lodash',
            saveAs: 'libs/FileSaver',
            d3: '../node_modules/d3/d3.min',
            modernizr: 'libs/modernizr',
            pdfkit: 'libs/pdfkit',
            impromptu: 'libs/jquery-impromptu.min',
            jstree: 'libs/jstree.min',
            cookie: 'libs/jquery.cookie',
            dropbox: 'libs/dropbox.min',
            protoplast: '../node_modules/protoplast/dist/protoplast',
            acceptance: '../test/acceptance',
            'aw-parser': '../node_modules/aw-parser/dist/aw-parser.amd',
            'aw-liner': '../node_modules/aw-liner/dist/aw-liner.amd',
            text: '../node_modules/text/text',
            Blob: 'libs/Blob'
        },
        shim: {
            handlebars: {
                exports: 'Handlebars'
            },
            logger: {
                exports: 'Logger'
            },
            saveAs: {
                exports: 'saveAs'
            },
            modernizr: {
                exports: 'Modernizr'
            },
            dropbox: {
                exports: 'Dropbox'
            },
            Blob: {
                exports: 'Blob'
            }
        }
    });

    // __TEST and __COVERAGE global vars are generated by template task
    // when creating runner.html and coverage.html test runners
    if (typeof __TEST !== 'undefined') {
        config.baseUrl = '../js/';
        require.config(config);
    }
    else if (typeof __COVERAGE !== 'undefined') {
        config.baseUrl = '../coverage/js/';
        require.config(config);
    }
})();